#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
try:
    import MySQLdb
except ImportError:
    MySQLdb = None


from clcommon.utils import run_command
from clcommon.cpapi.cpapiexceptions import NotSupported, NoPackage


__cpname__ = 'Plesk'


def detect():
    return os.path.isfile('/usr/local/psa/version')

PSA_PATH = '/usr/local/psa/bin/admin'


def db_access(_exe_path=PSA_PATH):
    access = dict()
    access['login'] = 'admin'
    access['pass'] = run_command(cmd=[_exe_path, '--show-password']).strip()
    return access


def cpusers(_accsess=None, _dbname='psa'):
    if not MySQLdb:
        raise NoPackage('Can not connect to database; MySQL-python package not installed.')
    access = _accsess or db_access()
    dbhost = access.get('host', 'localhost')
    dblogin = access['login']
    dbpass = access['pass']
    db = MySQLdb.connect(host=dbhost, user=dblogin, passwd=dbpass, db=_dbname)
    cursor = db.cursor()
    sql = r"SELECT login FROM sys_users"
    cursor.execute(sql)
    cpusers_lst = [fetched_one[0] for fetched_one in cursor.fetchall()]
    db.close()
    return cpusers_lst


def dblogin_cplogin_pairs(cplogin_lst=None):
    raise NotSupported('Getting binding credentials in the database to the user name in the system is not currently '
                       'supported. Is under development.')


